-- Since the wowkedar is always visible, most tick and event callbacks are defined by this frame to reduce overhead (and spaghetti).
local willPlay,ringtone =  nil,nil
local zoneSpawnExclusions = {"Stormwind City","City of Ironforge","Darnassus","Orgrimmar","Undercity","Thunderbluff"}
-- WowkesenseFrame logic
local messageButton = nil;
local ready = false
indexOfTargetToCapture = 0;
wowkemonCurrentPlayerZone = GetZoneText();
WowkemonMessageLive = false;
local totalSteps = 0;
local stepTimer = 0;
WildWowkemonIsAvailable = false;
-- local minimumStepsForEncounter = 6000;
local playerIsMoving = false;
local flashTime = 0;

-- TICK EVENT
WowkesenseFrame:SetScript("OnUpdate",function(self,elapsed)
  local inrange = false;
  local inBannedZone = false;
  local redStrength = 1;
  local distanceToTarget = {0,0}
  local baseDivForEncounter = 6000
  local encounterChance = 20
  local speed =  GetUnitSpeed("player") /7 * 100;
  name,data = GetInstanceInfo();
  if WowkesenseCaptureAlertFrame:IsShown() == true then
    flashTime = flashTime + elapsed;
    if flashTime <= 1 then
      WowkesenseFrame.AlertColor:SetColorTexture(1,0,0,0)
        WowkesenseFrame.CaptureFrameText:Hide()
    elseif flashTime > 1 and flashTime < 2 then
      WowkesenseFrame.AlertColor:SetColorTexture(1,0,0,1)
        WowkesenseFrame.CaptureFrameText:Show()
    end
    if flashTime > 2 then
      flashTime = 0;
    end
  end
  if messageButton ~=nil and messageButton:IsShown() == true then
    flashTime = flashTime + elapsed;
    if flashTime <= 1 then
      messageButton.texture:SetColorTexture(0,0,1,1)
      messageButton.text:Show()
    elseif flashTime > 1 and flashTime < 2 then
      messageButton.texture:SetColorTexture(0,0,1,0)
      messageButton.text:Hide()
    end
    if flashTime > 2 then
      flashTime = 0;
    end
  end
  if name == "Eastern Kingdoms"  or name == "Kalimdor"  then
    for e in pairs(zoneSpawnExclusions) do
      if e == GetZoneText() then
        inBannedZone = true;
      end
    end
    if WildWowkemonIsAvailable == false and playerIsMoving == true and inBannedZone == false then
      stepTimer = stepTimer + elapsed;
      if stepTimer >= 0.33 then
        totalSteps = totalSteps + (speed / 100);
        if   WowkemonDebugShowSpawnChance == true then
          print("Spawn chance: "..round(totalSteps/baseDivForEncounter,3))
        end
        stepTimer = 0;
        local spawnRoll = round(math.random() * 100,2)
        if spawnRoll < (round(totalSteps / baseDivForEncounter,6)) then
          print("|cffFFff00 a wild Wowkemon has appeared! |r");
          WildWowkemonIsAvailable = true
          WowkesenseCaptureAlertFrame:Show()
      --    WowkesenseImage:SetColorTexture(0,1,0,0.7);
          totalSteps = 0;
        end
      end
    else
      if WowkemonDebugShowSpawnChance == true then
      print("available: "..tostring(WildWowkemonIsAvailable).." moving:"..tostring(playerIsMoving).." bannedzone?"..tostring(inBannedZone))
    end
    end
else -- Not in appropriate Region (in an instance)
  --  WowkesenseImage:SetColorTexture(1,1,1,0.7);
    WowkesenseCaptureAlertFrame:Hide()
  end

end)


--- END TICK EVENT


-- REGISTER EVENTS
WowkesenseFrame:RegisterEvent("ADDON_LOADED")
WowkesenseFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
WowkesenseFrame:RegisterEvent("MAIL_SHOW")
WowkesenseFrame:RegisterEvent("GOSSIP_SHOW")
WowkesenseFrame:RegisterEvent("PLAYER_STARTED_MOVING")
WowkesenseFrame:RegisterEvent("PLAYER_STOPPED_MOVING")

WowkesenseFrame:SetScript("OnEvent",function(self,event,arg1,arg2,arg4,arg5,arg6,arg7,arg8,arg9,arg10)
if event == "ADDON_LOADED" and arg1 == "Wowkemon_Classic" then

    makeScrollerFrame(wowkedexPanel)
    HideAllWindowChildren()
  WowkemonDayLoot = {nil,nil}
--  RenewSpawns();
  LastSpawnRefreshTime = GetTime();
  ready = true;
  if tutorialStatuses[3] == nil then
    CreateRadarMessageButton("tutorial")
  end
elseif event == "ZONE_CHANGED_NEW_AREA" then
  refreshTextVariables(true)
  Wowkemon__wait(1.5,updateZoneText)
  Wowkemon__wait(2,forceRefreshLocalInfo)

elseif event == "MAIL_SHOW" then
  local zone = GetZoneText();
--  print(zone)
  if tutorialStatuses[2] == false then
    CreateRadarMessageButton("mailtutorial")
    tutorialStatuses[2] = true;
  end
    if PointsOfInterest[zone][2].lastVisisted ~= date("%m/%d/%y") then
      PointsOfInterest[zone][2].lastVisisted = date("%m/%d/%y")
      selectRandomMailLoot()
  --  print(date("%m/%d/%y"))
    else
      print("|cffFFff00 Wowkemon: Nothing here for you!|r");
    end

elseif event == "GOSSIP_SHOW" then -- on open Gossip window
  local zone = GetZoneText();
  local options,type = GetGossipOptions()
    if type ~= nil then -- is type valid?
      if type == "binder" then -- type checks.  -  is innkeeper?
        if tutorialStatuses[1] == false then -- are we on the tutorial?
          CreateRadarMessageButton("innkeepertutorial")
          tutorialStatuses[1] = true;
        else    -- Not on Tutorial
          if PointsOfInterest[zone] ~= nil then
          if PointsOfInterest[zone][1].lastVisisted ~= date("%m/%d/%y") then -- Have we not been here today?
            PointsOfInterest[zone][1].lastVisisted = date("%m/%d/%y")
            local selection = math.random(2) -- select quest type
            if selection == 1 then
              CreateRadarMessageButton("kill quest");
            elseif selection == 2 then
              CreateRadarMessageButton("travel quest");
            end -- end select quest
          else
        --    print("|cffFFff00 Wowkemon: Been here already today.|r")
          end -- end if we'e been here today
          end -- does zone exist in POI table
        end -- end tutorial or not
      elseif type == "battlemaster" then
        checkTravelQuestsForInteractTarget(type)
      end -- type checks.
    else -- type not nil

    end -- end gossip event

  elseif event == "PLAYER_STARTED_MOVING" then
    playerIsMoving = true
  elseif event == "PLAYER_STOPPED_MOVING" then
    playerIsMoving = false
end -- End main Event == checks

end)

-- END REGISTER EVENTS


-- GLOBAL FUNCTIONS
function InitialiseCaptureEvent()  -- Always called by CAPTURE button
  CaptureWindowLive = true;
  local subZone = GetSubZoneText();
  local spawnID,uniqueLoc = selectWowkemonToSpawn(subZone,unique);
  WowkemonCaptureFrame:Show()
  WowkemonEncounterIntroHandler(spawnID,uniqueLoc)
  if tutorialStatuses[3] == nil or tutorialStatuses[3] < 2 then
    CreateRadarMessageButton("tutorial2")
    tutorialStatuses[3] = 2;
  end
end

-- SELECT THE WOWKEMON TO SPAWN --
function selectWowkemonToSpawn(subZone)
  local uniqueSpawns = {};
  local spawnTypeChosen = false;
  local uniqueAvailable = false
  local isUnique = false
  local selection = nil;
  for e in pairs(wowkemonUniqueSpawnLocs) do -- Check for unique spawns in the current sub zone
    if e == subZone then
      uniqueAvailable = true
      table.insert(uniqueSpawns, wowkemonUniqueSpawnLocs[e])
    end
  end
  if uniqueAvailable == true then -- If unique spawns are available in the current sub zone
    for e in pairs(uniqueSpawns) do -- roll the spawn chance of each unique wokwemon
      for f in pairs(uniqueSpawns[e]) do
        if uniqueSpawns[e][f][4] ~= nil then
          if math.random(100) < uniqueSpawns[e][f][4] then  -- spawn chance success
            spawnTypeChosen = true;
            selection = e;  -- Assign the spawned wowkemon
            isUnique = true;
            break
          end
        end
      end
    end
  end
  if spawnTypeChosen == false then --  If unique spawn chance failed, select randomly from global table
    selection = math.random(StandardWowkemonSpawnTableLength)
  end
    return selection,isUnique
end


function updateZoneText()
  wowkemonCurrentPlayerZone =   GetZoneText();
  refreshTextVariables()
end


function CreateRadarMessageButton(dialogKey)
  print("|cffFFff00 Wowkemon: You have a new message!|r")
  if messageButton == nil then
    messageButton = CreateFrame("Button","WowkedarMessageButton",WowkesenseFrame)
    messageButton:SetSize(60,55)
    messageButton.texture = messageButton:CreateTexture(nil,"BACKGROUND",5)
    messageButton.texture:SetPoint("CENTER",WowkesenseFrame,"CENTER",0,13)
    messageButton.texture:SetHeight(messageButton:GetHeight()-5)
    messageButton.texture:SetWidth(messageButton:GetWidth()-5)
    messageButton:SetPoint("CENTER",WowkesenseFrame,"CENTER",0,15)
    messageButton.text = messageButton:CreateFontString(nil,"OVERLAY","GameFontNormal");
    messageButton.text:SetPoint("CENTER")
    messageButton:SetFrameLevel(6)
    messageButton.text:SetText("?")
    willplay, ringtone = PlaySoundFile(WDir.."\\resources\\sound\\jingle_ring.mp3")
    messageButton:SetScript("OnClick", function()  WowkemonMenuBody:Show() HideAllWindowChildren()  WowkemonMessageLive = true CreateWowkedexChatFrame(dialogKey) messageButton:Hide() if ringtone ~= nil then StopSound(ringtone) end end)
  else
    willplay,ringtone = PlaySoundFile(WDir.."\\resources\\sound\\jingle_ring.mp3")
    messageButton:SetScript("OnClick", function() WowkemonMenuBody:Show()  HideAllWindowChildren() WowkemonMessageLive = true  CreateWowkedexChatFrame(dialogKey) messageButton:Hide() if ringtone ~= nil then StopSound(ringtone) end end)
    messageButton:Show();
end
end


function WowkemonCaughtEvent() -- called when player successfuly captures a wowkemon.
  if tutorialStatuses[3] < 3 or  tutorialStatuses[3] == nil then  -- Tutorial progression support.
    CreateRadarMessageButton("tutorial3")
    tutorialStatuses[3] = 3
  end
end


function selectRandomMailLoot()
local maxItems = 10;
local cubes = math.random(10)
WowkemonAddItem("Capture Cube",cubes);
end
