-- actual wowkedex log.
local HeaderBackdrop =
{
    bgFile = "",
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
    tile = false, tileSize = 16, edgeSize = 16,
    insets = { left = 3, right = 3, top = 5, bottom = 3 }
}

local builtState = false;
local scrollFrameRef = nil;
local wowkedexFrames = {}
local frameHolder = nil;
local childscroll = nil;
local column = 0
local row = 0
local spaceR = 100;
local spaceC = -100;
local offsetX = 15;
local offsetY = -20;

function makeScrollerFrame(inFrame)
if builtState == false then
frameHolder = inFrame -- or CreateFrame("Frame", nil, inFrame); -- re-size this to whatever size you wish your ScrollFrame to be, at this point


--if builtState == false then
--  builtState = true
frameHolder:SetHeight(WowkedexScreenWindowFrame:GetHeight()-50);
frameHolder:SetWidth(WowkedexScreenWindowFrame:GetWidth()-33);
frameHolder:SetPoint("BOTTOMLEFT",0,5)
frameHolder.scrollframe = frameHolder.scrollframe or CreateFrame("ScrollFrame", "ANewScrollFrame", frameHolder, "UIPanelScrollFrameTemplate");
frameHolder.scrollchild = frameHolder.scrollchild or CreateFrame("Frame"); -- not sure what happens if you do, but to be safe, don't parent this yet (or do anything with it)
-- define the scrollframe's objects/elementss
local scrollbarName = frameHolder.scrollframe:GetName()
frameHolder.scrollbar = _G[scrollbarName.."ScrollBar"];
frameHolder.scrollupbutton = _G[scrollbarName.."ScrollBarScrollUpButton"];
frameHolder.scrolldownbutton = _G[scrollbarName.."ScrollBarScrollDownButton"];
-- all of these objects will need to be re-anchored (if not, they appear outside the frame and about 30 pixels too high)
frameHolder.scrollupbutton:ClearAllPoints();
frameHolder.scrollupbutton:SetPoint("TOPRIGHT", frameHolder.scrollframe, "TOPRIGHT", -2, -2);
frameHolder.scrolldownbutton:ClearAllPoints();
frameHolder.scrolldownbutton:SetPoint("BOTTOMRIGHT", frameHolder.scrollframe, "BOTTOMRIGHT", -2, 2);
frameHolder.scrollbar:ClearAllPoints();
frameHolder.scrollbar:SetPoint("TOP", frameHolder.scrollupbutton, "BOTTOM", 0, -2);
frameHolder.scrollbar:SetPoint("BOTTOM", frameHolder.scrolldownbutton, "TOP", 0, 2);
-- now officially set the scrollchild as your Scroll Frame's scrollchild (this also parents frameHolder.scrollchild to frameHolder.scrollframe)
-- IT IS IMPORTANT TO ENSURE THAT YOU SET THE SCROLLCHILD'S SIZE AFTER REGISTERING IT AS A SCROLLCHILD:
frameHolder.scrollframe:SetScrollChild(frameHolder.scrollchild);
-- set frameHolder.scrollframe points to the first frame that you created (in this case, frameHolder)
frameHolder.scrollframe:SetAllPoints(frameHolder);
-- now that SetScrollChild has been defined, you are safe to define your scrollchild's size. Would make sense to make it's height > scrollframe's height,
-- otherwise there's no point having a scrollframe!
-- note: you may need to define your scrollchild's height later on by calculating the combined height of the content that the scrollchild's child holds.
-- (see the bit below about showing content).
frameHolder.scrollchild:SetSize(frameHolder.scrollframe:GetWidth(), ( frameHolder.scrollframe:GetHeight() ));
-- THE SCROLLFRAME IS COMPLETE AT THIS POINT.  THE CODE BELOW DEMONSTRATES HOW TO SHOW DATA ON IT.
-- you need yet another frame which will be used to parent your widgets etc to.  This is the frame which will actually be seen within the Scroll Frame
-- It is parented to the scrollchild.  I like to think of scrollchild as a sort of 'pin-board' that you can 'pin' a piece of paper to (or take it back off)
frameHolder.childFrame = frameHolder.childFrame or CreateFrame("Frame", nil, frameHolder.scrollchild);
frameHolder.childFrame:SetAllPoints(frameHolder.scrollchild);
--end
local wowkemonTexturePath
local exists = false;
for w,k in pairs(WowkemonPlayerData["Wowkedex"]) do
  exists = false;
  for e in pairs(Wowkemons) do
    if Wowkemons[e][1] == w then
      wowkemonTexturePath = Wowkemons[e][2]
      break
    end
  end
  if row == 3 then
    column = column + 1
    row = 0
  end
  if exists == false then
    local frame = CreateFrame("Frame","wowkedexEntry"..w,frameHolder.scrollchild)
    frame:SetPoint("TOPLEFT",frameHolder.scrollchild,"TOPLEFT",(row*spaceR)+ offsetX,(column*spaceC)+offsetY)
    frame:SetSize(80,80)
    frame:SetBackdrop(HeaderBackdrop)
    local btn = CreateFrame("Button","wowkedexBtn"..w,frame)
    frame.text = frame:CreateFontString(nil,"OVERLAY","GameFontNormal")
    frame.text:SetText(w)
    frame.text:SetPoint("TOP",frame,"TOP",0,10)
    frame.texture = frame:CreateTexture(nil,"OVERLAY");
    frame.texture:SetTexture(wowkemonTexturePath)
    frame.texture:SetSize(frame:GetSize())
    frame.texture:SetPoint("CENTER",frame,"CENTER")
    btn:SetSize(frame:GetSize())
    btn:SetPoint("CENTER","wowkedexEntry"..w,"CENTER")
    btn:SetScript("OnClick", function() makeWowkemonDetailFrame(w,inFrame) end)
    row = row + 1;
    table.insert(wowkedexFrames,w);
  end
end
builtState = true;
frameHolder.scrollchild:SetSize(frameHolder.scrollframe:GetWidth(), ( frameHolder.scrollframe:GetHeight() * math.max((column/2),1) ) )

frameHolder = frameHolder;
else
end
frameHolder:Show()
scrollFrameRef = frameHolder;
return frameHolder
end


function makeWowkemonDetailFrame(dataKey,inFrame)
scrollFrameRef:Hide();
local textContent = dataKey.."\nTotal Captures: "..WowkemonPlayerData["Wowkedex"][dataKey][2].."\nHighest level: "..WowkemonPlayerData["Wowkedex"][dataKey][3].."\nTotal Candy: "..WowkemonPlayerData["Wowkedex"][dataKey][1];
wowkemonPanel:Show()
wowkemonPanel:SetSize(wowkedexPanel:GetSize());
wowkemonPanel:SetPoint("TOPLEFT",WowkedexScreenWindowFrame,"TOPLEFT")
wowkemonPanel.textContent:SetText(textContent)
wowkemonPanel.textContent:SetPoint("TOPLEFT",wowkemonPanel,"TOPLEFT",20,-45)
wowkemonPanel.textContent:SetSize(wowkedexPanel:GetSize())
--wowkemonPanel.textContent:SetPoint("CENTER",wowkedexPanel,"CENTER")
--wowkemonPanel.textContent:SetPoint("CENTER")
--WowkemonPlayerData["Wowkedex"][dataKey]
end

function addToWowkedexList(wowkemon)
  local wowkemonTexturePath
    for e in pairs(Wowkemons) do
      if Wowkemons[e][1] == wowkemon[1] then
        wowkemonTexturePath = Wowkemons[e][2]
        break
      end
    end
    if row == 3 then
      column = column + 1
      row = 0
    end
      local frame = CreateFrame("Frame","wowkedexEntry"..wowkemon[1],frameHolder.scrollchild)
      frame:SetPoint("TOPLEFT",frameHolder.scrollchild,"TOPLEFT",(row*spaceR)+ offsetX,(column*spaceC)+offsetY)
      frame:SetSize(80,80)
      frame:SetBackdrop(HeaderBackdrop)
      local btn = CreateFrame("Button","wowkedexBtn"..wowkemon[1],frame)
      frame.text = frame:CreateFontString(nil,"OVERLAY","GameFontNormal")
      frame.text:SetText(wowkemon[1])
      frame.text:SetPoint("TOP",frame,"TOP",0,10)
      frame.texture = frame:CreateTexture(nil,"OVERLAY");
      frame.texture:SetTexture(wowkemonTexturePath)
      frame.texture:SetSize(frame:GetSize())
      frame.texture:SetPoint("CENTER",frame,"CENTER")
      btn:SetSize(frame:GetSize())
      btn:SetPoint("CENTER","wowkedexEntry"..wowkemon[1],"CENTER")
      btn:SetScript("OnClick", function() makeWowkemonDetailFrame(wowkemon[1],frameHolder) end)
      row = row + 1;
      table.insert(wowkedexFrames,wowkemon[1]);

    frameHolder.scrollchild:SetSize(frameHolder.scrollframe:GetWidth(), ( frameHolder.scrollframe:GetHeight() * math.max((column/2),1) ) )
end
